--- old/usr/src/cmd/perl/contrib/Sun/Solaris/Project/Project.xs	Tue Apr 22 05:37:44 2014
+++ new/usr/src/cmd/perl/contrib/Sun/Solaris/Project/Project.xs	Tue Apr 22 05:37:44 2014
@@ -1,5 +1,6 @@
 /*
  * Copyright (c) 1999, 2007, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2014 Racktop Systems.
  */
 /*
  * Project.xs contains XS wrappers for the project database maniplulation
@@ -160,7 +161,7 @@
 	char		buf[PROJECT_BUFSZ];
 PPCODE:
 	PUTBACK;
-	if (projp = getprojent(&proj, buf, sizeof (buf))) {
+	if ((projp = getprojent(&proj, buf, sizeof (buf)))) {
 		XSRETURN(pushret_project(projp));
 	} else {
 		XSRETURN_EMPTY;
@@ -180,7 +181,7 @@
 	char		buf[PROJECT_BUFSZ];
 PPCODE:
 	PUTBACK;
-	if (projp = getprojbyname(name, &proj, buf, sizeof (buf))) {
+	if ((projp = getprojbyname(name, &proj, buf, sizeof (buf)))) {
 		XSRETURN(pushret_project(projp));
 	} else {
 		XSRETURN_EMPTY;
@@ -194,7 +195,7 @@
 	char		buf[PROJECT_BUFSZ];
 PPCODE:
 	PUTBACK;
-	if (projp = getprojbyid(id, &proj, buf, sizeof (buf))) {
+	if ((projp = getprojbyid(id, &proj, buf, sizeof (buf)))) {
 		XSRETURN(pushret_project(projp));
 	} else {
 		XSRETURN_EMPTY;
@@ -208,7 +209,7 @@
 	char		buf[PROJECT_BUFSZ];
 PPCODE:
 	PUTBACK;
-	if (projp = getdefaultproj(user, &proj, buf, sizeof (buf))) {
+	if ((projp = getdefaultproj(user, &proj, buf, sizeof (buf)))) {
 		XSRETURN(pushret_project(projp));
 	} else {
 		XSRETURN_EMPTY;
@@ -222,7 +223,7 @@
 	char		buf[PROJECT_BUFSZ];
 PPCODE:
 	PUTBACK;
-	if (projp = fgetprojent(fh, &proj, buf, sizeof (buf))) {
+	if ((projp = fgetprojent(fh, &proj, buf, sizeof (buf)))) {
 		XSRETURN(pushret_project(projp));
 	} else {
 		XSRETURN_EMPTY;
@@ -270,7 +271,7 @@
 	rctlblk_t *tmp = NULL;
 	rctl_priv_t priv;
 	rctl_qty_t value;
-	int flags;
+	int flags = 0;
 	int ret;
 	int err = 0;
 	char string[24];	/* 24 will always hold a uint64_t */
--- /dev/null	Tue Apr 22 05:37:44 2014
+++ new/usr/src/cmd/perl/contrib/Sun/Solaris/Project/mapfile-vers	Tue Apr 22 05:37:44 2014
@@ -0,0 +1,36 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+#
+# Copyright (c) 2014 Racktop Systems.
+#
+
+$mapfile_version 2
+
+SYMBOL_SCOPE {
+    global:
+	boot_Sun__Solaris__Project;
+	XS_Sun__Solaris__Project_activeprojects;
+	XS_Sun__Solaris__Project_endprojent;
+	XS_Sun__Solaris__Project_fgetprojent;
+	XS_Sun__Solaris__Project_getdefaultproj;
+	XS_Sun__Solaris__Project_getprojbyid;
+	XS_Sun__Solaris__Project_getprojbyname;
+	XS_Sun__Solaris__Project_getprojent;
+	XS_Sun__Solaris__Project_getprojid;
+	XS_Sun__Solaris__Project_getprojidbyname;
+	XS_Sun__Solaris__Project_inproj;
+	XS_Sun__Solaris__Project_pool_exists;
+	XS_Sun__Solaris__Project_rctl_get_info;
+	XS_Sun__Solaris__Project_setproject;
+	XS_Sun__Solaris__Project_setprojent;
+    local:
+	*;
+};
--- /dev/null	Tue Apr 22 05:37:44 2014
+++ new/usr/src/cmd/perl/contrib/Sun/Solaris/Task/Makefile	Tue Apr 22 05:37:44 2014
@@ -0,0 +1,33 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+#
+# Copyright (c) 2014 Racktop Systems.
+# Copyright 2014, OmniTI Computer Consulting, Inc. All rights reserved.
+#
+
+MODULE = Task
+
+include $(SRC)/cmd/perl/Makefile.perl
+
+XSUBPPFLAGS = -typemap typemap
+
+MAPFILES = mapfile-vers
+
+include $(SRC)/cmd/perl/Makefile.targ
+
+.KEEP_STATE:
+
+all: $(PERLEXT) $(PERLMOD) $(PERLEXT64)
+
+install: $(ROOTPERLEXT) $(ROOTPERLMOD) $(ROOTPERLEXT64) $(ROOTPERLMOD64)
+
+clean clobber:
+	$(RM) -r $(MACH) $(MACH64)
--- old/usr/src/cmd/perl/contrib/Sun/Solaris/Task/Task.pm	Tue Apr 22 05:37:44 2014
+++ new/usr/src/cmd/perl/contrib/Sun/Solaris/Task/Task.pm	Tue Apr 22 05:37:44 2014
@@ -1,5 +1,6 @@
 #
 # Copyright (c) 2002, 2008, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2014 Racktop Systems.
 #
 
 #
@@ -6,7 +7,7 @@
 # Task.pm provides the bootstrap for the Sun::Solaris::Task module.
 #
 
-require 5.8.4;
+require 5.0010;
 use strict;
 use warnings;
 
--- /dev/null	Tue Apr 22 05:37:44 2014
+++ new/usr/src/cmd/perl/contrib/Sun/Solaris/Task/mapfile-vers	Tue Apr 22 05:37:44 2014
@@ -0,0 +1,24 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+#
+# Copyright (c) 2014 Racktop Systems.
+#
+
+$mapfile_version 2
+
+SYMBOL_SCOPE {
+    global:
+	boot_Sun__Solaris__Task;
+	XS_Sun__Solaris__Task_gettaskid;
+	XS_Sun__Solaris__Task_settaskid;
+    local:
+	*;
+};
--- /dev/null	Tue Apr 22 05:37:44 2014
+++ new/usr/src/cmd/perl/contrib/Sun/Solaris/Utils/Makefile	Tue Apr 22 05:37:44 2014
@@ -0,0 +1,31 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+#
+# Copyright (c) 2014 Racktop Systems.
+# Copyright 2014, OmniTI Computer Consulting, Inc. All rights reserved.
+#
+
+MODULE = Utils
+
+include $(SRC)/cmd/perl/Makefile.perl
+
+MAPFILES = mapfile-vers
+
+include $(SRC)/cmd/perl/Makefile.targ
+
+.KEEP_STATE:
+
+all: $(PERLEXT) $(PERLMOD) $(PERLEXT64)
+
+install: $(ROOTPERLEXT) $(ROOTPERLMOD) $(ROOTPERLEXT64) $(ROOTPERLMOD64)
+
+clean clobber:
+	$(RM) -r $(MACH) $(MACH64)
--- /dev/null	Tue Apr 22 05:37:44 2014
+++ new/usr/src/cmd/perl/contrib/Sun/Solaris/Utils/mapfile-vers	Tue Apr 22 05:37:44 2014
@@ -0,0 +1,28 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+#
+# Copyright (c) 2014 Racktop Systems.
+#
+
+$mapfile_version 2
+
+SYMBOL_SCOPE {
+    global:
+	boot_Sun__Solaris__Utils;
+	XS_Sun__Solaris__Utils_bindtextdomain;
+	XS_Sun__Solaris__Utils_dcgettext;
+	XS_Sun__Solaris__Utils_dgettext;
+	XS_Sun__Solaris__Utils_gettext;
+	XS_Sun__Solaris__Utils_gmatch;
+	XS_Sun__Solaris__Utils_textdomain;
+    local:
+	*;
+};
--- old/usr/src/cmd/zdb/zdb.c	Tue Apr 22 05:37:44 2014
+++ new/usr/src/cmd/zdb/zdb.c	Tue Apr 22 05:37:44 2014
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2012, 2014 by Delphix. All rights reserved.
  */
 
 #include <stdio.h>
@@ -2749,7 +2749,8 @@
 		dds.dds_ref_psize = zdde->zdde_ref_psize;
 		dds.dds_ref_dsize = zdde->zdde_ref_dsize;
 
-		ddt_stat_add(&ddh_total.ddh_stat[highbit(refcnt) - 1], &dds, 0);
+		ddt_stat_add(&ddh_total.ddh_stat[highbit64(refcnt) - 1],
+		    &dds, 0);
 
 		umem_free(zdde, sizeof (*zdde));
 	}
--- old/usr/src/head/uuid/uuid.h	Tue Apr 22 05:37:45 2014
+++ new/usr/src/head/uuid/uuid.h	Tue Apr 22 05:37:45 2014
@@ -24,11 +24,13 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2014 Andrew Stormont.
+ */
+
 #ifndef	_UUID_H
 #define	_UUID_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifdef	__cplusplus
 extern "C" {
 #endif
@@ -65,6 +67,8 @@
 extern void uuid_copy(uuid_t, uuid_t);
 extern void uuid_clear(uuid_t);
 extern void uuid_unparse(uuid_t, char *);
+extern void uuid_unparse_lower(uuid_t, char *);
+extern void uuid_unparse_upper(uuid_t, char *);
 extern int uuid_compare(uuid_t, uuid_t);
 extern int uuid_is_null(uuid_t);
 extern int uuid_parse(char *, uuid_t);
--- old/usr/src/lib/libdtrace/common/dt_decl.c	Tue Apr 22 05:37:45 2014
+++ new/usr/src/lib/libdtrace/common/dt_decl.c	Tue Apr 22 05:37:45 2014
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2012, 2014 by Delphix. All rights reserved.
  * Copyright (c) 2013 Joyent, Inc. All rights reserved.
  */
 
@@ -267,6 +267,26 @@
 		return (ddp);
 	}
 
+	if ((attr & DT_DA_LONG) && (ddp->dd_attr & DT_DA_LONGLONG)) {
+		xyerror(D_DECL_COMBO, "the attribute 'long' may only "
+		    "be used at most twice in a declaration");
+	}
+
+	if ((attr & DT_DA_SHORT) && (ddp->dd_attr & DT_DA_SHORT)) {
+		xyerror(D_DECL_COMBO, "the attribute 'short' may only be "
+		    "used at most once in a declaration");
+	}
+
+	if ((attr & DT_DA_SIGNED) && (ddp->dd_attr & DT_DA_SIGNED)) {
+		xyerror(D_DECL_COMBO, "the attribute 'signed' may only be "
+		    "used at most once in a declaration");
+	}
+
+	if ((attr & DT_DA_UNSIGNED) && (ddp->dd_attr & DT_DA_UNSIGNED)) {
+		xyerror(D_DECL_COMBO, "the attribute 'unsigned' may only be "
+		    "used at most once in a declaration");
+	}
+
 	if (attr == DT_DA_LONG && (ddp->dd_attr & DT_DA_LONG)) {
 		ddp->dd_attr &= ~DT_DA_LONG;
 		attr = DT_DA_LONGLONG;
--- old/usr/src/lib/libuuid/common/mapfile-vers	Tue Apr 22 05:37:45 2014
+++ new/usr/src/lib/libuuid/common/mapfile-vers	Tue Apr 22 05:37:45 2014
@@ -20,6 +20,7 @@
 #
 #
 # Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 #
@@ -38,6 +39,12 @@
 
 $mapfile_version 2
 
+SYMBOL_VERSION ILLUMOS_0.1 {
+    global:
+	uuid_unparse_lower;
+	uuid_unparse_upper;
+} SUNW_1.1;
+
 SYMBOL_VERSION SUNW_1.1 {
     global:
 	uuid_clear;
--- old/usr/src/lib/libuuid/common/uuid.c	Tue Apr 22 05:37:45 2014
+++ new/usr/src/lib/libuuid/common/uuid.c	Tue Apr 22 05:37:45 2014
@@ -23,6 +23,7 @@
  * Use is subject to license terms.
  * Copyright 2012 Milan Jurik. All rights reserved.
  * Copyright 2013 Joyent, Inc. All rights reserved.
+ * Copyright 2014 Andrew Stormont.
  */
 
 /*
@@ -578,8 +579,8 @@
  * binary format into a 36-byte string (plus trailing null char)
  * and stores this value in the character string pointed to by out.
  */
-void
-uuid_unparse(uuid_t uu, char *out)
+static void
+uuid_unparse_common(uuid_t uu, char *out, boolean_t upper)
 {
 	struct uuid 	uuid;
 	uint16_t	clock_seq;
@@ -591,26 +592,44 @@
 		return;
 	}
 
-	/* XXX user should have allocated enough memory */
-	/*
-	 * if (strlen(out) < UUID_PRINTABLE_STRING_LENGTH) {
-	 * return;
-	 * }
-	 */
 	string_to_struct(&uuid, uu);
 	clock_seq = uuid.clock_seq_hi_and_reserved;
 	clock_seq = (clock_seq  << 8) | uuid.clock_seq_low;
 	for (i = 0; i < 6; i++) {
-		(void) sprintf(&etheraddr[index++], "%.2x", uuid.node_addr[i]);
+		(void) sprintf(&etheraddr[index++], upper ? "%.2X" : "%.2x",
+		    uuid.node_addr[i]);
 		index++;
 	}
 	etheraddr[index] = '\0';
 
-	(void) snprintf(out, 25, "%08x-%04x-%04x-%04x-",
+	(void) snprintf(out, 25,
+	    upper ? "%08X-%04X-%04X-%04X-" : "%08x-%04x-%04x-%04x-",
 	    uuid.time_low, uuid.time_mid, uuid.time_hi_and_version, clock_seq);
 	(void) strlcat(out, etheraddr, UUID_PRINTABLE_STRING_LENGTH);
 }
 
+void
+uuid_unparse_upper(uuid_t uu, char *out)
+{
+	uuid_unparse_common(uu, out, B_TRUE);
+}
+
+void
+uuid_unparse_lower(uuid_t uu, char *out)
+{
+	uuid_unparse_common(uu, out, B_FALSE);
+}
+
+void
+uuid_unparse(uuid_t uu, char *out)
+{
+	/*
+	 * Historically uuid_unparse on Solaris returns lower case,
+	 * for compatibility we preserve this behaviour.
+	 */
+	uuid_unparse_common(uu, out, B_FALSE);
+}
+
 /*
  * The uuid_is_null function compares the value of the supplied
  * UUID variable uu to the NULL value. If the value is equal
--- old/usr/src/lib/libzpool/common/kernel.c	Tue Apr 22 05:37:45 2014
+++ new/usr/src/lib/libzpool/common/kernel.c	Tue Apr 22 05:37:45 2014
@@ -20,7 +20,7 @@
  */
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2012 by Delphix. All rights reserved.
+ * Copyright (c) 2012, 2014 by Delphix. All rights reserved.
  * Copyright (c) 2013, Joyent, Inc.  All rights reserved.
  */
 
@@ -772,20 +772,17 @@
 /*
  * Find highest one bit set.
  *	Returns bit number + 1 of highest bit that is set, otherwise returns 0.
- * High order bit is 31 (or 63 in _LP64 kernel).
  */
 int
-highbit(ulong_t i)
+highbit64(uint64_t i)
 {
-	register int h = 1;
+	int h = 1;
 
 	if (i == 0)
 		return (0);
-#ifdef _LP64
-	if (i & 0xffffffff00000000ul) {
+	if (i & 0xffffffff00000000ULL) {
 		h += 32; i >>= 32;
 	}
-#endif
 	if (i & 0xffff0000) {
 		h += 16; i >>= 16;
 	}
--- old/usr/src/lib/libzpool/common/sys/zfs_context.h	Tue Apr 22 05:37:45 2014
+++ new/usr/src/lib/libzpool/common/sys/zfs_context.h	Tue Apr 22 05:37:45 2014
@@ -21,7 +21,7 @@
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
- * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2012, 2014 by Delphix. All rights reserved.
  * Copyright (c) 2012, Joyent, Inc. All rights reserved.
  */
 
@@ -516,7 +516,7 @@
 
 extern uint64_t physmem;
 
-extern int highbit(ulong_t i);
+extern int highbit64(uint64_t i);
 extern int random_get_bytes(uint8_t *ptr, size_t len);
 extern int random_get_pseudo_bytes(uint8_t *ptr, size_t len);
 
--- old/usr/src/man/man3perl/Makefile	Tue Apr 22 05:37:45 2014
+++ new/usr/src/man/man3perl/Makefile	Tue Apr 22 05:37:45 2014
@@ -12,6 +12,7 @@
 #
 # Copyright 2011, Richard Lowe
 # Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+# Copyright (c) 2014 Racktop Systems.
 #
 
 include		$(SRC)/Makefile.master
@@ -18,38 +19,13 @@
 
 MANSECT=	3perl
 
-MANFILES=	Exacct.3perl			\
-	 	Exacct\:\:Catalog.3perl		\
-	 	Exacct\:\:File.3perl		\
-	 	Exacct\:\:Object.3perl		\
-	 	Exacct\:\:Object\:\:Group.3perl \
-	 	Exacct\:\:Object\:\:Item.3perl	\
-	 	Kstat.3perl			\
+MANFILES=	Kstat.3perl			\
 	 	Lgrp.3perl			\
-	 	Privilege.3perl			\
 	 	Project.3perl			\
-	 	Task.3perl			\
-	 	Ucred.3perl
+	 	Task.3perl
 
 .KEEP_STATE:
 
 include		$(SRC)/man/Makefile.man
 
-#
-# When KEEP_STATE is in effect and a target has a colon in the name (like the
-# Exacct::* pages above, dmake will write them to the state file unescaped,
-# creating a file which then cannot be reparsed, breaking any build other than
-# the first in this directory:
-#
-# See CR 6987108 make will write un-escaped :'s to .make.state, break itself
-#
-# As a workaround, install the files manually in a FRC target.
-CMD= $(INS) -s -m $(FILEMODE) -f $(ROOTMAN)/man$(MANSECT)
-install: FRC
-	@for file in $(MANFILES); do					\
-		if [[ $$file -nt $(ROOTMAN)/man$(MANSECT)/$$file ]]; then \
-			$(ECHO) $(CMD) $$file;				\
-			$(RM) $(ROOTMAN)/man$(MANSECT)/$$file;		\
-			$(CMD) $$file;					\
-		fi							\
-	done;
+install: $(ROOTMANFILES) $(ROOTMANLINKS)
--- old/usr/src/man/man3uuid/Makefile	Tue Apr 22 05:37:45 2014
+++ new/usr/src/man/man3uuid/Makefile	Tue Apr 22 05:37:45 2014
@@ -12,6 +12,7 @@
 #
 # Copyright 2011, Richard Lowe
 # Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 include		$(SRC)/Makefile.master
@@ -28,7 +29,9 @@
 		uuid_is_null.3uuid		\
 		uuid_parse.3uuid		\
 		uuid_time.3uuid			\
-		uuid_unparse.3uuid
+		uuid_unparse.3uuid		\
+		uuid_unparse_lower.3uuid	\
+		uuid_unparse_upper.3uuid
 
 uuid_compare.3uuid		:= LINKSRC = uuid_clear.3uuid
 uuid_copy.3uuid			:= LINKSRC = uuid_clear.3uuid
@@ -39,6 +42,8 @@
 uuid_parse.3uuid		:= LINKSRC = uuid_clear.3uuid
 uuid_time.3uuid			:= LINKSRC = uuid_clear.3uuid
 uuid_unparse.3uuid		:= LINKSRC = uuid_clear.3uuid
+uuid_unparse_lower.3uuid	:= LINKSRC = uuid_clear.3uuid
+uuid_unparse_upper.3uuid	:= LINKSRC = uuid_clear.3uuid
 
 .KEEP_STATE:
 
--- old/usr/src/man/man3uuid/uuid_clear.3uuid	Tue Apr 22 05:37:45 2014
+++ new/usr/src/man/man3uuid/uuid_clear.3uuid	Tue Apr 22 05:37:45 2014
@@ -1,13 +1,15 @@
 '\" te
 .\" Copyright (c) 2006, Sun Microsystems, Inc. All Rights Reserved.
+.\" Copyright 2014 Andrew Stormont.
 .\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License").  You may not use this file except in compliance with the License.
 .\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.  See the License for the specific language governing permissions and limitations under the License.
 .\" When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE.  If applicable, add the following below this CDDL HEADER, with the fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
-.TH UUID_CLEAR 3UUID "Jan 16, 2006"
+.TH UUID_CLEAR 3UUID "Apr 9, 2014"
 .SH NAME
 uuid_clear, uuid_compare, uuid_copy, uuid_generate, uuid_generate_random,
-uuid_generate_time, uuid_is_null, uuid_parse, uuid_time, uuid_unparse \-
-universally unique identifier (UUID) operations
+uuid_generate_time, uuid_is_null, uuid_parse, uuid_time, uuid_unparse,
+uuid_unparse_lower, uuid_unparse_upper \- universally unique identifier (UUID)
+operations
 .SH SYNOPSIS
 .LP
 .nf
@@ -62,6 +64,16 @@
 \fBvoid\fR \fBuuid_unparse\fR(\fBuuid_t\fR \fIuu\fR, \fBchar *\fR\fIout\fR);
 .fi
 
+.LP
+.nf
+\fBvoid\fR \fBuuid_unparse_lower\fR(\fBuuid_t\fR \fIuu\fR, \fBchar *\fR\fIout\fR);
+.fi
+
+.LP
+.nf
+\fBvoid\fR \fBuuid_unparse_upper\fR(\fBuuid_t\fR \fIuu\fR, \fBchar *\fR\fIout\fR);
+.fi
+
 .SH DESCRIPTION
 .sp
 .LP
@@ -121,11 +133,18 @@
 to by \fBret_tv\fR (see \fBgettimeofday\fR(3C)).
 .sp
 .LP
-The \fBuuid_unparse()\fR function converts the specified UUID \fIuu\fR from the
-internal binary format to a string of the length defined in the \fBuuid.h\fR
-macro, \fBUUID_PRINTABLE_STRING_LENGTH\fR, which includes the trailing null
-character. The resulting value is stored in the character string pointed to by
-\fIout\fR.
+The \fBuuid_unparse()\fR and \fBuuid_unparse_lower()\fR functions convert the
+specified UUID \fIuu\fR from the internal binary format to a lower case string
+of the length defined in the \fBuuid.h\fR macro,
+\fBUUID_PRINTABLE_STRING_LENGTH\fR, which includes the trailing null character.
+The resulting value is stored in the character string pointed to by \fIout\fR.
+.sp
+.LP
+The \fBuuid_unparse_upper()\fR function converts the specified UUID \fIuu\fR
+from the internal binary format to a upper case string of the length defined in
+the \fBuuid.h\fR macro, \fBUUID_PRINTABLE_STRING_LENGTH\fR, which includes the
+trailing null character. The resulting value is stored in the character string
+pointed to by \fIout\fR.
 .SH ATTRIBUTES
 .sp
 .LP
--- old/usr/src/pkg/manifests/system-dtrace-tests.mf	Tue Apr 22 05:37:46 2014
+++ new/usr/src/pkg/manifests/system-dtrace-tests.mf	Tue Apr 22 05:37:46 2014
@@ -21,7 +21,7 @@
 
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
-# Copyright (c) 2012 by Delphix. All rights reserved.
+# Copyright (c) 2012, 2014 by Delphix. All rights reserved.
 #
 
 set name=pkg.fmri value=pkg:/system/dtrace/tests@$(PKGVERS)
@@ -1944,6 +1944,11 @@
     mode=0444
 file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_COMBO.badtype4.d mode=0444
 file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_COMBO.badtype5.d mode=0444
+file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_COMBO.rptdattr1.d mode=0444
+file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_COMBO.rptdattr2.d mode=0444
+file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_COMBO.rptdattr3.d mode=0444
+file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_COMBO.rptdattr4.d mode=0444
+file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_COMBO.rptdattr5.d mode=0444
 file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_ENCONST.badeval.d mode=0444
 file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_ENOFLOW.enoflow.d mode=0444
 file path=opt/SUNWdtrt/tst/common/types/err.D_DECL_ENOFLOW.enuflow.d mode=0444
@@ -1968,6 +1973,8 @@
 file path=opt/SUNWdtrt/tst/common/types/err.D_UNKNOWN.dupstruct.d mode=0444
 file path=opt/SUNWdtrt/tst/common/types/err.D_XLATE_REDECL.ResultDynType.d \
     mode=0444
+file path=opt/SUNWdtrt/tst/common/types/err.EDT_NOTYPE.cmbdatt1.d mode=0444
+file path=opt/SUNWdtrt/tst/common/types/err.EDT_NOTYPE.cmbdatt2.d mode=0444
 file path=opt/SUNWdtrt/tst/common/types/tst.assignops.d mode=0444
 file path=opt/SUNWdtrt/tst/common/types/tst.badshiftops.d mode=0444
 file path=opt/SUNWdtrt/tst/common/types/tst.basics.d mode=0444
--- old/usr/src/pkg/manifests/system-library.man3uuid.inc	Tue Apr 22 05:37:46 2014
+++ new/usr/src/pkg/manifests/system-library.man3uuid.inc	Tue Apr 22 05:37:46 2014
@@ -12,6 +12,7 @@
 #
 # Copyright 2011, Richard Lowe
 # Copyright 2012 Nexenta Systems, Inc. All rights reserved.
+# Copyright 2014 Andrew Stormont.
 #
 
 file path=usr/share/man/man3uuid/uuid_clear.3uuid
@@ -26,3 +27,7 @@
 link path=usr/share/man/man3uuid/uuid_parse.3uuid target=uuid_clear.3uuid
 link path=usr/share/man/man3uuid/uuid_time.3uuid target=uuid_clear.3uuid
 link path=usr/share/man/man3uuid/uuid_unparse.3uuid target=uuid_clear.3uuid
+link path=usr/share/man/man3uuid/uuid_unparse_lower.3uuid \
+    target=uuid_clear.3uuid
+link path=usr/share/man/man3uuid/uuid_unparse_upper.3uuid \
+    target=uuid_clear.3uuid
--- old/usr/src/uts/common/fs/zfs/dbuf.c	Tue Apr 22 05:37:46 2014
+++ new/usr/src/uts/common/fs/zfs/dbuf.c	Tue Apr 22 05:37:46 2014
@@ -21,7 +21,7 @@
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
- * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2012, 2014 by Delphix. All rights reserved.
  * Copyright (c) 2013 by Saso Kiselkov. All rights reserved.
  * Copyright (c) 2013, Joyent, Inc. All rights reserved.
  */
@@ -40,6 +40,7 @@
 #include <sys/dmu_zfetch.h>
 #include <sys/sa.h>
 #include <sys/sa_impl.h>
+#include <sys/range_tree.h>
 
 /*
  * Number of times that zfs_free_range() took the slow path while doing
@@ -1177,7 +1178,10 @@
 	if (db->db_level == 0 && db->db_blkid != DMU_BONUS_BLKID &&
 	    db->db_blkid != DMU_SPILL_BLKID) {
 		mutex_enter(&dn->dn_mtx);
-		dnode_clear_range(dn, db->db_blkid, 1, tx);
+		if (dn->dn_free_ranges[txgoff] != NULL) {
+			range_tree_clear(dn->dn_free_ranges[txgoff],
+			    db->db_blkid, 1);
+		}
 		mutex_exit(&dn->dn_mtx);
 		db->db_freed_in_flight = FALSE;
 	}
--- old/usr/src/uts/common/fs/zfs/ddt.c	Tue Apr 22 05:37:46 2014
+++ new/usr/src/uts/common/fs/zfs/ddt.c	Tue Apr 22 05:37:46 2014
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2012, 2014 by Delphix. All rights reserved.
  */
 
 #include <sys/zfs_context.h>
@@ -402,7 +402,7 @@
 
 	ddt_stat_generate(ddt, dde, &dds);
 
-	bucket = highbit(dds.dds_ref_blocks) - 1;
+	bucket = highbit64(dds.dds_ref_blocks) - 1;
 	ASSERT(bucket >= 0);
 
 	ddh = &ddt->ddt_histogram[dde->dde_type][dde->dde_class];
--- old/usr/src/uts/common/fs/zfs/dnode.c	Tue Apr 22 05:37:46 2014
+++ new/usr/src/uts/common/fs/zfs/dnode.c	Tue Apr 22 05:37:46 2014
@@ -20,7 +20,7 @@
  */
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2012, 2014 by Delphix. All rights reserved.
  */
 
 #include <sys/zfs_context.h>
@@ -35,9 +35,8 @@
 #include <sys/spa.h>
 #include <sys/zio.h>
 #include <sys/dmu_zfetch.h>
+#include <sys/range_tree.h>
 
-static int free_range_compar(const void *node1, const void *node2);
-
 static kmem_cache_t *dnode_cache;
 /*
  * Define DNODE_STATS to turn on statistic gathering. By default, it is only
@@ -90,9 +89,7 @@
 
 	for (i = 0; i < TXG_SIZE; i++) {
 		list_link_init(&dn->dn_dirty_link[i]);
-		avl_create(&dn->dn_ranges[i], free_range_compar,
-		    sizeof (free_range_t),
-		    offsetof(struct free_range, fr_node));
+		dn->dn_free_ranges[i] = NULL;
 		list_create(&dn->dn_dirty_records[i],
 		    sizeof (dbuf_dirty_record_t),
 		    offsetof(dbuf_dirty_record_t, dr_dirty_node));
@@ -140,7 +137,7 @@
 
 	for (i = 0; i < TXG_SIZE; i++) {
 		ASSERT(!list_link_active(&dn->dn_dirty_link[i]));
-		avl_destroy(&dn->dn_ranges[i]);
+		ASSERT3P(dn->dn_free_ranges[i], ==, NULL);
 		list_destroy(&dn->dn_dirty_records[i]);
 		ASSERT0(dn->dn_next_nblkptr[i]);
 		ASSERT0(dn->dn_next_nlevels[i]);
@@ -313,19 +310,6 @@
 	}
 }
 
-static int
-free_range_compar(const void *node1, const void *node2)
-{
-	const free_range_t *rp1 = node1;
-	const free_range_t *rp2 = node2;
-
-	if (rp1->fr_blkid < rp2->fr_blkid)
-		return (-1);
-	else if (rp1->fr_blkid > rp2->fr_blkid)
-		return (1);
-	else return (0);
-}
-
 void
 dnode_setbonuslen(dnode_t *dn, int newsize, dmu_tx_t *tx)
 {
@@ -374,7 +358,7 @@
 	    1<<(sizeof (dn->dn_phys->dn_datablkszsec) * 8));
 	dn->dn_datablksz = size;
 	dn->dn_datablkszsec = size >> SPA_MINBLOCKSHIFT;
-	dn->dn_datablkshift = ISP2(size) ? highbit(size - 1) : 0;
+	dn->dn_datablkshift = ISP2(size) ? highbit64(size - 1) : 0;
 }
 
 static dnode_t *
@@ -530,7 +514,7 @@
 		ASSERT0(dn->dn_next_blksz[i]);
 		ASSERT(!list_link_active(&dn->dn_dirty_link[i]));
 		ASSERT3P(list_head(&dn->dn_dirty_records[i]), ==, NULL);
-		ASSERT0(avl_numnodes(&dn->dn_ranges[i]));
+		ASSERT3P(dn->dn_free_ranges[i], ==, NULL);
 	}
 
 	dn->dn_type = ot;
@@ -694,7 +678,8 @@
 		list_move_tail(&ndn->dn_dirty_records[i],
 		    &odn->dn_dirty_records[i]);
 	}
-	bcopy(&odn->dn_ranges[0], &ndn->dn_ranges[0], sizeof (odn->dn_ranges));
+	bcopy(&odn->dn_free_ranges[0], &ndn->dn_free_ranges[0],
+	    sizeof (odn->dn_free_ranges));
 	ndn->dn_allocated_txg = odn->dn_allocated_txg;
 	ndn->dn_free_txg = odn->dn_free_txg;
 	ndn->dn_assigned_txg = odn->dn_assigned_txg;
@@ -757,8 +742,7 @@
 		list_create(&odn->dn_dirty_records[i],
 		    sizeof (dbuf_dirty_record_t),
 		    offsetof(dbuf_dirty_record_t, dr_dirty_node));
-		odn->dn_ranges[i].avl_root = NULL;
-		odn->dn_ranges[i].avl_numnodes = 0;
+		odn->dn_free_ranges[i] = NULL;
 		odn->dn_next_nlevels[i] = 0;
 		odn->dn_next_indblkshift[i] = 0;
 		odn->dn_next_bonustype[i] = 0;
@@ -1462,59 +1446,6 @@
 }
 
 void
-dnode_clear_range(dnode_t *dn, uint64_t blkid, uint64_t nblks, dmu_tx_t *tx)
-{
-	avl_tree_t *tree = &dn->dn_ranges[tx->tx_txg&TXG_MASK];
-	avl_index_t where;
-	free_range_t *rp;
-	free_range_t rp_tofind;
-	uint64_t endblk = blkid + nblks;
-
-	ASSERT(MUTEX_HELD(&dn->dn_mtx));
-	ASSERT(nblks <= UINT64_MAX - blkid); /* no overflow */
-
-	dprintf_dnode(dn, "blkid=%llu nblks=%llu txg=%llu\n",
-	    blkid, nblks, tx->tx_txg);
-	rp_tofind.fr_blkid = blkid;
-	rp = avl_find(tree, &rp_tofind, &where);
-	if (rp == NULL)
-		rp = avl_nearest(tree, where, AVL_BEFORE);
-	if (rp == NULL)
-		rp = avl_nearest(tree, where, AVL_AFTER);
-
-	while (rp && (rp->fr_blkid <= blkid + nblks)) {
-		uint64_t fr_endblk = rp->fr_blkid + rp->fr_nblks;
-		free_range_t *nrp = AVL_NEXT(tree, rp);
-
-		if (blkid <= rp->fr_blkid && endblk >= fr_endblk) {
-			/* clear this entire range */
-			avl_remove(tree, rp);
-			kmem_free(rp, sizeof (free_range_t));
-		} else if (blkid <= rp->fr_blkid &&
-		    endblk > rp->fr_blkid && endblk < fr_endblk) {
-			/* clear the beginning of this range */
-			rp->fr_blkid = endblk;
-			rp->fr_nblks = fr_endblk - endblk;
-		} else if (blkid > rp->fr_blkid && blkid < fr_endblk &&
-		    endblk >= fr_endblk) {
-			/* clear the end of this range */
-			rp->fr_nblks = blkid - rp->fr_blkid;
-		} else if (blkid > rp->fr_blkid && endblk < fr_endblk) {
-			/* clear a chunk out of this range */
-			free_range_t *new_rp =
-			    kmem_alloc(sizeof (free_range_t), KM_SLEEP);
-
-			new_rp->fr_blkid = endblk;
-			new_rp->fr_nblks = fr_endblk - endblk;
-			avl_insert_here(tree, new_rp, rp, AVL_AFTER);
-			rp->fr_nblks = blkid - rp->fr_blkid;
-		}
-		/* there may be no overlap */
-		rp = nrp;
-	}
-}
-
-void
 dnode_free_range(dnode_t *dn, uint64_t off, uint64_t len, dmu_tx_t *tx)
 {
 	dmu_buf_impl_t *db;
@@ -1664,22 +1595,15 @@
 	 * We will finish up this free operation in the syncing phase.
 	 */
 	mutex_enter(&dn->dn_mtx);
-	dnode_clear_range(dn, blkid, nblks, tx);
-	{
-		free_range_t *rp, *found;
-		avl_index_t where;
-		avl_tree_t *tree = &dn->dn_ranges[tx->tx_txg&TXG_MASK];
-
-		/* Add new range to dn_ranges */
-		rp = kmem_alloc(sizeof (free_range_t), KM_SLEEP);
-		rp->fr_blkid = blkid;
-		rp->fr_nblks = nblks;
-		found = avl_find(tree, rp, &where);
-		ASSERT(found == NULL);
-		avl_insert(tree, rp, where);
-		dprintf_dnode(dn, "blkid=%llu nblks=%llu txg=%llu\n",
-		    blkid, nblks, tx->tx_txg);
+	int txgoff = tx->tx_txg & TXG_MASK;
+	if (dn->dn_free_ranges[txgoff] == NULL) {
+		dn->dn_free_ranges[txgoff] =
+		    range_tree_create(NULL, NULL, &dn->dn_mtx);
 	}
+	range_tree_clear(dn->dn_free_ranges[txgoff], blkid, nblks);
+	range_tree_add(dn->dn_free_ranges[txgoff], blkid, nblks);
+	dprintf_dnode(dn, "blkid=%llu nblks=%llu txg=%llu\n",
+	    blkid, nblks, tx->tx_txg);
 	mutex_exit(&dn->dn_mtx);
 
 	dbuf_free_range(dn, blkid, blkid + nblks - 1, tx);
@@ -1707,7 +1631,6 @@
 uint64_t
 dnode_block_freed(dnode_t *dn, uint64_t blkid)
 {
-	free_range_t range_tofind;
 	void *dp = spa_get_dsl(dn->dn_objset->os_spa);
 	int i;
 
@@ -1727,21 +1650,11 @@
 	if (blkid == DMU_SPILL_BLKID)
 		return (dnode_spill_freed(dn));
 
-	range_tofind.fr_blkid = blkid;
 	mutex_enter(&dn->dn_mtx);
 	for (i = 0; i < TXG_SIZE; i++) {
-		free_range_t *range_found;
-		avl_index_t idx;
-
-		range_found = avl_find(&dn->dn_ranges[i], &range_tofind, &idx);
-		if (range_found) {
-			ASSERT(range_found->fr_nblks > 0);
+		if (dn->dn_free_ranges[i] != NULL &&
+		    range_tree_contains(dn->dn_free_ranges[i], blkid, 1))
 			break;
-		}
-		range_found = avl_nearest(&dn->dn_ranges[i], idx, AVL_BEFORE);
-		if (range_found &&
-		    range_found->fr_blkid + range_found->fr_nblks > blkid)
-			break;
 	}
 	mutex_exit(&dn->dn_mtx);
 	return (i < TXG_SIZE);
